Subject: RE: [rohc] doubt in sigcomp :- P-Bit

From: [email-masked]
Date: Wed, 22 Sep 2004 12:39:27 +0530

Hi Zacco

Thanks for your response. I have doubt in "INPUT-BYTE wrt to P-Bit" ,
section 2.12 in Sigcomp-Torture-test-draft
[draft-price-rohc-sigcomp-torture-tests-02.txt] :-

  section 2.12 from Torture-test-draft :-
  ========================================

   at (64)

    :byte_copy_left                 pad (2)
    :byte_copy_right                pad (2)
    :input_bit_order                pad (2)
    :result                         pad (2)
    :output_start                   pad (4)
    :output_end

    at (128)

    LOAD (byte_copy_left, output_start)
    LOAD (byte_copy_right, output_end)

    :start

    INPUT-BITS ($input_bit_order, result, end_of_message)
    OUTPUT (result, 2)

    ADD ($input_bit_order, 2)
    REMAINDER ($input_bit_order, 7)

    INPUT-BYTES ($input_bit_order, output_start, end_of_message)
    OUTPUT (output_start, $input_bit_order)

    ADD ($input_bit_order, 1)
    JUMP (start)

    :end_of_message

    END-MESSAGE (0, 0, 0, 0, 0, 0, 0)

    An example compressed message is 0x932e ac71 66d8 6fb1 592b dc9a 9734
    d847 a733 874e 1bcb cd51 b5dc 9659 9d6a, which decompresses to give
    the output 0x0000 932e 0001 b166 d86f b100 1a2b 0003 9a97 34d8 0007
    0001 3387 4e00 08dc 9651 b5dc 9600 599d 6a.

    DRY RUN (when P-Bit is considered for INPUT-BYTE)
    ==================================================
      ==================
       loc| register
      ==================
        64| byte-copy-left
        66| byte-copy-right
        68| input-bit-order
        70| result
        72| output-start
        76| output-end

    Round-1 :
      INPUT-BITS(0,result)  -> 0 bits are read
      OUTPUT(result,2)      -> 00,00 is output to decompression-ptr

      ADD(0,2)              -> memory[68] = 2
      REMAINDER(2,7)        -> memory[68] = 2
      INPUT-BYTES(2,result) -> Read 2 bytes from compressed-msg.
                               Input-Bit-Order is 2 => p-bit is not set
                               so read 93 2e from input compressed msg .
                               memory[72] = 93
                               memory[73] = 2e
      OUTPUT(72,2)          -> Output   93 2e to decompression-ptr.
      ADD(2,1)              -> memory[68] = 3 (input-bit-order is 3)

      JUMP (START)

   Round-2 :
      INPUT-BITS(3)         -> input-bit-order is 3 => p_bit is set
                               so read in reverse-order
                               compressed-ptr is on ac71...
                               we read bits 001 and set at 70 location
      OUTPUT(70,2)          -> 00 01 is output to decompression ptr

      ADD(3,2)              -> memory[68] = 5 (input-bit-order is 5)
      REMAINDER(5,7)        -> memory[68] = 5 (input-bit-order is 5)

      INPUT-BYTE(5,output-start) -> Since the ptr is mid-way in  third byte
                                    so discard 5 bits.
                                    Since P-bit is set so read in reverse
order
                                    memory[72] = reverse(71)
                                    memory[73] = reverse(66)
                                    memory[74] = reverse(d8)
                                    memory[75] = reverse(6f)
                                    memory[72] = reverse(b1)
(byte-registers)
                                    So outcome is
                                    Set 0x8e at 72 loc
                                    Set 0x66 at 73 loc
                                    Set 0x1b at 74 loc
                                    Set 0xf6 at 75 loc
                                    Set 0x8d at 72 loc

      OUTPUT(70,5)             -> 8d 66 1b f6 is output

      If you check the output as per draft then it is b166 d86f b1 (which
is
      comperssed-msg not reversed). If we do not take care of P-Bit for
      INPUT-BYTES the output becomes same as given in torture draft.

      Please clarify this.

thanks and regards
Jyoti

"Lajos Zaccomer (IJ/ETH)" <[email-masked]> wrote on 09/21/2004
12:23:23 PM:

> Hi Jyoti,
>
> You seem to confuse the register itself and one of its bits. The
> input bit order register contains three bits: F, H and P. And the
> RFC 3320 says: "The P-bit controls the order in which bits are
> passed from the dispatcher to the INPUT instructions."
> So, in brief: P applies to all three input instructions, but F
> applies to INPUT-BITS only and H applies to INPUT-HUFFMAN only as an
> additional flag besides P bit, to change behaviour.
>
> br/Zacco
>
> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On Behalf
> Of [email-masked]
> Sent: Tuesday, September 21, 2004 7:45 AM
> To: [email-masked]
> Subject: [rohc] doubt in sigcomp :- P-Bit
>
>
>
>
>
>
>
> Hi all
>
> I have a doubt in P-Bit of Input-Bit-Order register :
>
> As per RFC 3320 , section 8.2 :-
>       "Note that the INPUT-BITS and INPUT-HUFFMAN instructions retrieve a
>    stream of individual compressed bits from the dispatcher.  To provide
>    bitwise compatibility with various well-known compression algorithms,
>    the input_bit_order register can modify the order in which individual
>    bits are passed within a byte."
>
> This points to the fact that P-Bit will not effect Input-Byte
instruction.
> The register Input-Bit-Order shall effect only the "Input-Bits" and
> "Input-Huffmann" instructions. Please clarify if the value of P-Bit
> effect the order of reading bits in byte for INPUT-BYTES instruction.
> (Some parts of the same section seems to suggest that P-Bit will
> effect the order of bits in all the INPUT instructions.)
>
> thanks and regards
> Jyoti
>
> =======================================
> Jyoti Bhalla
> Hughes Software Systems
> Bangalore
> India
> http://www.hssworld.com
> =======================================
>
>
>
> ***********************  HSS-Unclassified   ***********************
> "DISCLAIMER: This message is proprietary to Hughes Software Systems
Limited
> (HSS) and is intended solely for the use of the individual to whom it is
> addressed. It may contain  privileged or confidential information and
> should not be circulated or used for any purpose other than for what it
is
> intended. If you have received this message in error, please notify the
> originator immediately. If you are not the intended recipient, you are
> notified that you are strictly prohibited from using, copying, altering,
or
> disclosing the contents of this message. HSS accepts no responsibility
for
> loss or damage arising from the use of the information transmitted by
this
> email including damage from virus."
>
>
> _______________________________________________
> Rohc mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/rohc

***********************  HSS-Unclassified   ***********************

***********************  HSS-Unclassified   ***********************
"DISCLAIMER: This message is proprietary to Hughes Software Systems Limited
(HSS) and is intended solely for the use of the individual to whom it is
addressed. It may contain  privileged or confidential information and
should not be circulated or used for any purpose other than for what it is
intended. If you have received this message in error, please notify the
originator immediately. If you are not the intended recipient, you are
notified that you are strictly prohibited from using, copying, altering, or
disclosing the contents of this message. HSS accepts no responsibility for
loss or damage arising from the use of the information transmitted by this
email including damage from virus."

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: [email-masked]
Date: Wed, 29 Sep 2004 17:47:55 +0530

Hi all

I am re-sending the message as i did not receieve any response.

thanks
Jyoti

----- Forwarded by Jyoti Bhalla/BLR/HSS on 09/29/04 05:50 PM -----
                                                                           
             jbhalla@hssworld.                                             
             com                                                           
             Sent by:                                                   To 
             rohc-bounces@ietf         "Lajos Zaccomer (IJ/ETH)"           
             .org                      <[email-masked]>,      
                                       [email-masked]                       
                                                                        cc 
             09/22/04 12:39 PM                                             
                                                                   Subject 
                                       RE: [rohc] doubt in sigcomp :-      
                                       P-Bit                               

                                                                           

Hi Zacco

   at (64)

    :byte_copy_left                 pad (2)
    :byte_copy_right                pad (2)
    :input_bit_order                pad (2)
    :result                         pad (2)
    :output_start                   pad (4)
    :output_end

    at (128)

    :start

    :end_of_message

    Round-1 :

      JUMP (START)

   Round-2 :

      Please clarify this.

thanks and regards
Jyoti

instruction.
Limited
is
or
for
this